package DEFLATE.DEFLATE;

import Bytes.Bytes.ByteArray;
import references.references.*;

import static Bits.Bitwise.Bitwise.*;
import static Bytes.Bytes.Bytes.*;
import static java.lang.Math.*;
import static math.math.math.*;
import static references.references.references.*;

public class DEFLATE {
    /*public static double [] InflateData(double [] data){
        NumberReference nextbit;
        DeflateData deflateData;
        boolean done;
        double [] result;
        double next, len, nlen;

        result = new double [10000];
        next = 0;

        deflateData = new DeflateData();

        nextbit = CreateNumberReference(0d);

        done = false;

        for(; !done;) {
            deflateData.BFINAL = ReadNextBit(data, nextbit);
            deflateData.BTYPE = ReadBitRange(data, nextbit, 2d);

            if(deflateData.BTYPE == 0d){
                // Uncompressed
                SkipToBoundary(nextbit);
                len = Read2bytesByteBoundary(data, nextbit);
                nlen = Read2bytesByteBoundary(data, nextbit);
            }

            if (deflateData.BFINAL == 1d) {
                done = true;
            }
        }

        return result;
    }*/

    public static ByteArray DeflateDataStaticHuffman(ByteArray data, double level) {
        ByteArray bytes;
        NumberReference currentBit;
        double i;
        ByteArray copy;
        NumberReference code, length, compressedCode, lengthAdditionLength, distanceCode;
        NumberReference distanceReference, lengthReference, lengthAddition;
        NumberReference distanceAdditionReference, distanceAdditionLengthReference;
        double [] bitReverseLookupTable;
        BooleanReference match;

        code = CreateNumberReference(0d);
        length = CreateNumberReference(0d);
        compressedCode = CreateNumberReference(0d);
        lengthAdditionLength = CreateNumberReference(0d);
        distanceCode = CreateNumberReference(0d);
        distanceReference = CreateNumberReference(0d);
        lengthReference = CreateNumberReference(0d);
        lengthAddition = CreateNumberReference(0d);
        distanceAdditionReference = CreateNumberReference(0d);
        distanceAdditionLengthReference = CreateNumberReference(0d);
        match = new BooleanReference();

        bytes = CreateAndFillByteArray(max(ByteArrayLength(data) * 2d, 100d), 0d);
        currentBit = CreateNumberReference(0d);

        bitReverseLookupTable = GenerateBitReverseLookupTable(9d);

        // Final block
        AppendBitsToBytesRight(bytes, currentBit, 1d, 1d);
        // Fixed code
        AppendBitsToBytesRight(bytes, currentBit, 1d, 2d);

        for(i = 0d; i < ByteArrayLength(data); ){
            FindMatch(data, i, distanceReference, lengthReference, match, level);

            if(match.booleanValue){
                GetDeflateLengthCode(lengthReference.numberValue, compressedCode, lengthAddition, lengthAdditionLength);
                GetDeflateDistanceCode(distanceReference.numberValue, distanceCode, distanceAdditionReference, distanceAdditionLengthReference, bitReverseLookupTable);
            }

            if(!match.booleanValue) {
                GetDeflateStaticHuffmanCode(GetByte(data, i), code, length, bitReverseLookupTable);
                AppendBitsToBytesRight(bytes, currentBit, code.numberValue, length.numberValue);
                i = i + 1d;
            }else{
                GetDeflateStaticHuffmanCode(compressedCode.numberValue, code, length, bitReverseLookupTable);
                AppendBitsToBytesRight(bytes, currentBit, code.numberValue, length.numberValue);
                AppendBitsToBytesRight(bytes, currentBit, lengthAddition.numberValue, lengthAdditionLength.numberValue);
                AppendBitsToBytesRight(bytes, currentBit, distanceCode.numberValue, 5d);
                AppendBitsToBytesRight(bytes, currentBit, distanceAdditionReference.numberValue, distanceAdditionLengthReference.numberValue);
                i = i + lengthReference.numberValue;
            }
        }

        // Stop symbol
        GetDeflateStaticHuffmanCode(256d, code, length, bitReverseLookupTable);
        AppendBitsToBytesRight(bytes, currentBit, code.numberValue, length.numberValue);

        copy = new ByteArray();
        CopyByteArrayRange(bytes, 0d, ceil(currentBit.numberValue/8d), copy);
        delete(bytes);

        return copy;
    }

    public static void FindMatch(ByteArray data, double pos, NumberReference distanceReference, NumberReference lengthReference, BooleanReference match, double level) {
        double i, j;
        double deflateMinMength, deflateMaxLength, deflateMaxDistance;
        double longest, maxLength, distanceForMax;
        double startDistance, matchLength;
        boolean done;

        deflateMinMength = 3d;
        deflateMaxLength = 258d;

        longest = min(pos - 1d, deflateMaxLength);
        longest = min(ByteArrayLength(data) - pos, longest);

        deflateMaxDistance = floor(32768d/10d * level);

        startDistance = min(pos, deflateMaxDistance);

        if(longest >= deflateMinMength) {
            maxLength = 0d;
            distanceForMax = 0d;

            for(i = pos - 1d; i >= pos-startDistance  && maxLength != longest; i = i - 1d){
                matchLength = 0d;
                done = false;
                for(j = 0d; j < longest && !done; j = j + 1d){
                    if(GetByte(data, i + j) == GetByte(data, pos + j)){
                        matchLength = matchLength + 1d;
                    }else{
                        done = true;
                    }
                }

                if(matchLength >= deflateMinMength && matchLength > maxLength){
                    maxLength = matchLength;
                    distanceForMax = pos - i;
                }
            }

            if(maxLength >= deflateMinMength){
                match.booleanValue = true;
                lengthReference.numberValue = maxLength;
                distanceReference.numberValue = distanceForMax;
            }else{
                match.booleanValue = false;
            }

        } else {
            match.booleanValue = false;
        }
    }

    public static double[] GenerateBitReverseLookupTable(double bits) {
        double [] table;
        double i;

        table = new double [(int)pow(2d, bits)];

        for(i = 0d; i < table.length; i = i + 1d){
            table[(int)i] = ReverseBits(i, 32d);
        }

        return table;
    }

    public static double ReverseBits(double x, double bits) {
        double b, bit, i;

        b = 0d;

        for(i = 0d; i < bits; i = i + 1d){
            b = ShiftLeft4Byte(b, 1d);
            bit = And4Byte(x, 1d);
            b = Or4Byte(b, bit);
            x = ShiftRight4Byte(x, 1d);
        }

        return b;
    }

    public static void delete(Object object){
        // Java has garbage collection.
    }

    public static ByteArray DeflateDataNoCompression(ByteArray data) {
        ByteArray deflated;
        NumberReference position;
        double block, i, blocks, blocklength, maxblocksize;

        maxblocksize = pow(2d, 16d) - 1d;
        blocks = ceil(ByteArrayLength(data) / maxblocksize);

        position = CreateNumberReference(0d);

        deflated = CreateByteArray((1d + 4d)*blocks + ByteArrayLength(data));

        for(block = 0d; block < blocks; block = block + 1d) {
            if(block + 1d == blocks) {
                WriteByte(deflated, 1d, position);
            }else{
                WriteByte(deflated, 0d, position);
            }
            blocklength = min(ByteArrayLength(data) - block * maxblocksize, maxblocksize);
            Write2BytesLE(deflated, blocklength, position);
            Write2BytesLE(deflated, Not2Byte(blocklength), position);

            for (i = 0d; i < blocklength; i = i + 1d) {
                WriteByte(deflated, GetByte(data, block * maxblocksize + i), position);
            }
        }

        return deflated;
    }

    public static void GetDeflateStaticHuffmanCode(double b, NumberReference code, NumberReference length, double[] bitReverseLookupTable){
        double reversed;

        if(b >= 0d && b <= 143d){
            code.numberValue = 48d + b;
            length.numberValue = 8d;
        }else if(b >= 144d && b <= 255d){
            code.numberValue = b - 144d + 400d;
            length.numberValue = 9d;
        }else if(b >= 256d && b <= 279d){
            code.numberValue = b - 256d + 0d;
            length.numberValue = 7d;
        }else if(b >= 280d && b <= 287d){
            code.numberValue = b - 280d + 192d;
            length.numberValue = 8d;
        }

        reversed = bitReverseLookupTable[(int) code.numberValue];
        code.numberValue = ShiftRight4Byte(reversed, 32d - length.numberValue);
    }

    public static void GetDeflateLengthCode(double length, NumberReference code, NumberReference lengthAddition, NumberReference lengthAdditionLength){
        if(length >= 3d && length <= 10d){
            code.numberValue = 257d + length - 3d;
            lengthAdditionLength.numberValue = 0d;
        }else if(length >= 11d && length <= 18d){
            code.numberValue = 265d + floor((length-11d)/2d);
            lengthAddition.numberValue = floor((length-11d)%2d);
            lengthAdditionLength.numberValue = 1d;
        }else if(length >= 19d && length <= 34d){
            code.numberValue = 269d + floor((length-19d)/4d);
            lengthAddition.numberValue = floor((length-19d)%4d);
            lengthAdditionLength.numberValue = 2d;
        }else if(length >= 35d && length <= 66d){
            code.numberValue = 273d + floor((length-35d)/8d);
            lengthAddition.numberValue = floor((length-35d)%8d);
            lengthAdditionLength.numberValue = 3d;
        }else if(length >= 67d && length <= 130d){
            code.numberValue = 277d + floor((length-67d)/16d);
            lengthAddition.numberValue = floor((length-67d)%16d);
            lengthAdditionLength.numberValue = 4d;
        }else if(length >= 131d && length <= 257d){
            code.numberValue = 281d + floor((length-131d)/32d);
            lengthAddition.numberValue = floor((length-131d)%32d);
            lengthAdditionLength.numberValue = 5d;
        }else if(length == 258d){
            code.numberValue = 285d;
            lengthAdditionLength.numberValue = 0d;
        }
    }

    public static void GetDeflateDistanceCode(double distance, NumberReference code, NumberReference distanceAdditionReference, NumberReference distanceAdditionLengthReference, double[] bitReverseLookupTable){
        double reversed;

        if(distance >= 1d && distance <= 4d){
            code.numberValue = distance - 1d;
            distanceAdditionLengthReference.numberValue = 0d;
        }else if(distance >= 5d && distance <= 8d) {
            code.numberValue = 4d + floor((distance - 5d)/2d);
            distanceAdditionReference.numberValue = floor((distance - 5d) % 2d);
            distanceAdditionLengthReference.numberValue = 1d;
        }else if(distance >= 9d && distance <= 16d) {
            code.numberValue = 6d + floor((distance - 9d)/4d);
            distanceAdditionReference.numberValue = floor((distance - 9d) % 4d);
            distanceAdditionLengthReference.numberValue = 2d;
        }else if(distance >= 17d && distance <= 32d) {
            code.numberValue = 8d + floor((distance - 17d) / 8d);
            distanceAdditionReference.numberValue = floor((distance - 17d) % 8d);
            distanceAdditionLengthReference.numberValue = 3d;
        }else if(distance >= 33d && distance <= 64d) {
            code.numberValue = 10d + floor((distance - 33d) / 16d);
            distanceAdditionReference.numberValue = floor((distance - 33d) % 16d);
            distanceAdditionLengthReference.numberValue = 4d;
        }else if(distance >= 65d && distance <= 128d) {
            code.numberValue = 12d + floor((distance - 65d) / 32d);
            distanceAdditionReference.numberValue = floor((distance - 65d) % 32d);
            distanceAdditionLengthReference.numberValue = 5d;
        }else if(distance >= 129d && distance <= 256d) {
            code.numberValue = 14d + floor((distance - 129d) / 64d);
            distanceAdditionReference.numberValue = floor((distance - 129d) % 64d);
            distanceAdditionLengthReference.numberValue = 6d;
        }else if(distance >= 257d && distance <= 512d) {
            code.numberValue = 16d + floor((distance - 257d) / 128d);
            distanceAdditionReference.numberValue = floor((distance - 257d) % 128d);
            distanceAdditionLengthReference.numberValue = 7d;
        }else if(distance >= 513d && distance <= 1024d) {
            code.numberValue = 18d + floor((distance - 513d) / 256d);
            distanceAdditionReference.numberValue = floor((distance - 513d) % 256d);
            distanceAdditionLengthReference.numberValue = 8d;
        }else if(distance >= 1025d && distance <= 2048d) {
            code.numberValue = 20d + floor((distance - 1025d) / pow(2d, 9d));
            distanceAdditionReference.numberValue = floor((distance - 1025d) % pow(2d, 9d));
            distanceAdditionLengthReference.numberValue = 9d;
        }else if(distance >= 2049d && distance <= 4096d) {
            code.numberValue = 22d + floor((distance - 2049d) / pow(2d, 10d));
            distanceAdditionReference.numberValue = floor((distance - 2049d) % pow(2d, 10d));
            distanceAdditionLengthReference.numberValue = 10d;
        }else if(distance >= 4097d && distance <= 8192d) {
            code.numberValue = 24d + floor((distance - 4097d) / pow(2d, 11d));
            distanceAdditionReference.numberValue = floor((distance - 4097d) % pow(2d, 11d));
            distanceAdditionLengthReference.numberValue = 11d;
        }else if(distance >= 8193d && distance <= 16384d) {
            code.numberValue = 26d + floor((distance - 8193d) / pow(2d, 12d));
            distanceAdditionReference.numberValue = floor((distance - 8193d) % pow(2d, 12d));
            distanceAdditionLengthReference.numberValue = 12d;
        }else if(distance >= 16385d && distance <= 32768d) {
            code.numberValue = 28d + floor((distance - 16385d) / pow(2d, 13d));
            distanceAdditionReference.numberValue = floor((distance - 16385d) % pow(2d, 13d));
            distanceAdditionLengthReference.numberValue = 13d;
        }

        reversed = bitReverseLookupTable[(int)code.numberValue];
        code.numberValue = ShiftRight4Byte(reversed, 32d - 5d);
    }

    public static void AppendBitsToBytesLeft(ByteArray bytes, NumberReference nextbit, double data, double length){
        double bytePos, bitPos, segment, part, remove;

        for(; length > 0d; ) {
            bytePos = Truncate(nextbit.numberValue / 8d);
            bitPos = nextbit.numberValue % 8d;

            if (length < 8d - bitPos) {
                part = ShiftLeft4Byte(data, 8d - bitPos - length);

                SetByte(bytes, bytePos, Or4Byte(GetByte(bytes, bytePos), part));

                nextbit.numberValue = nextbit.numberValue + length;

                length = 0d;
            } else {
                segment = 8d - bitPos;

                part = ShiftRight4Byte(data, length - segment);
                SetByte(bytes,  bytePos, Or4Byte(GetByte(bytes, bytePos), part));
                nextbit.numberValue = nextbit.numberValue + segment;

                remove = ShiftLeft4Byte(part, length - segment);
                data = Xor4Byte(data, remove);

                length = length - segment;
            }
        }
    }

    public static void AppendBitsToBytesRight(ByteArray bytes, NumberReference nextbit, double data, double length){
        double bytePos, bitPos, segment, part;
        double mask;

        for(; length > 0d; ) {
            bytePos = Truncate(nextbit.numberValue / 8d);
            bitPos = nextbit.numberValue % 8d;

            if (length < 8d - bitPos) {
                part = ShiftLeft4Byte(data, bitPos);

                SetByte(bytes, bytePos, Or4Byte(GetByte(bytes, bytePos), part));

                nextbit.numberValue = nextbit.numberValue + length;

                length = 0d;
            } else {
                segment = 8d - bitPos;

                mask = 1d;
                mask = ShiftLeft4Byte(mask, segment);
                mask = mask - 1d;

                part = And4Byte(mask, data);
                part = ShiftLeft4Byte(part, bitPos);
                SetByte(bytes, bytePos, Or4Byte(GetByte(bytes, bytePos), part));
                nextbit.numberValue = nextbit.numberValue + segment;

                data = ShiftRight4Byte(data, segment);

                length = length - segment;
            }
        }
    }
}



















