package DEFLATE.DEFLATETest;

import Bytes.Bytes.ByteArray;
import references.references.*;

import static Bytes.Bytes.Bytes.*;
import static DEFLATE.DEFLATE.DEFLATE.*;
import static arraysarrays.arrays.arrays.arraysStringToNumberArray;
import static java.lang.Math.*;
import static numbers.StringToNumber.StringToNumber.*;
import static references.references.references.*;

public class DEFLATETest {
    public static double test1() {
        ByteArray bytes, compressed;
        double [] bits, lengths;
        NumberReference failures;

        failures = CreateNumberReference(0d);

        compressed = new ByteArray();
        compressed.bytes = StringToNumberArray("115, 73, 77, 203, 73, 44, 73, 5, 13, 0".toCharArray());

        bits = StringToNumberArray("1, 1, 46, 169, 105, 57, 137, 37, 169, 32, 3, 0".toCharArray());
        lengths = StringToNumberArray("1, 2, 8, 8, 8, 8, 8, 8, 8, 7, 5, 7".toCharArray());

        bytes = PackBitsInByteArrayRight(bits, lengths);

        AssertByteArraysEqual(compressed, bytes, failures);

        return failures.numberValue;
    }

    public static double test2() {
        char [] testdata;
        ByteArray compressed;
        ByteArray bytes, data;
        NumberReference failures;

        failures = CreateNumberReference(0d);

        testdata = "Deflatelate".toCharArray();

        data = new ByteArray();
        data.bytes = arraysStringToNumberArray(testdata);

        compressed = new ByteArray();
        compressed.bytes = StringToNumberArray("115, 73, 77, 203, 73, 44, 73, 5, 97, 0".toCharArray());

        bytes = DeflateDataStaticHuffman(data, 10d);

        AssertByteArraysEqual(compressed, bytes, failures);

        return failures.numberValue;
    }

    public static double test3() {
        char [] testdata;
        ByteArray compressed;
        ByteArray bytes, data;
        NumberReference failures;

        failures = CreateNumberReference(0d);

        testdata = "".toCharArray();

        data = new ByteArray();
        data.bytes = arraysStringToNumberArray(testdata);

        compressed = new ByteArray();
        compressed.bytes = StringToNumberArray("3, 0".toCharArray());

        bytes = DeflateDataStaticHuffman(data, 10d);

        AssertByteArraysEqual(compressed, bytes, failures);

        return failures.numberValue;
    }

    public static ByteArray PackBitsInByteArrayRight(double[] bits, double[] lengths) {
        ByteArray bytes;
        NumberReference currentBit;
        double i;
        ByteArray copy;

        bytes = CreateAndFillByteArray(20d, 0d);
        currentBit = CreateNumberReference(0d);

        for(i = 0d; i < bits.length; i = i + 1d){
            AppendBitsToBytesRight(bytes, currentBit, bits[(int)i], lengths[(int)i]);
        }

        copy = new ByteArray();
        CopyByteArrayRange(bytes, 0d, ceil(currentBit.numberValue/8d), copy);
        delete(bytes);

        return copy;
    }

    public static void delete(Object object) {

    }
}
